/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2008 by TAKAGI Nobuhisa
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */
#include <cstdlib>
#include <stdlib.h>	// Cygwin΍
#include <cstring>
#include <clocale>
#include <string>
#include <map>
#include <fstream>
#include <stdexcept>
#include "toppers/gettext.hpp"
#include "toppers/cpp.hpp"
#include "toppers/global.hpp"
#include <boost/scoped_array.hpp>
#include <boost/any.hpp>
#include <boost/filesystem/path.hpp>
#include <boost/filesystem/operations.hpp>

namespace toppers
{
  namespace
  {

    std::map< std::string, std::string > msgcat;

    void register_msgcat( std::string const& msgid, std::string const& msgstr )
    {
      std::string::size_type size = msgstr.size();
      boost::scoped_array< wchar_t > wbuf( new wchar_t[ size + 1 ] );
      boost::scoped_array< char > buf( new char[ size + 1 ] );
      wchar_t* wcs = wbuf.get();
      wchar_t wc = 0;
      for ( std::string::const_iterator iter( msgstr.begin() ), last( msgstr.end() ); iter != last; ++iter )
      {
        int c = static_cast< unsigned char >( *iter );
        if ( ( ( c & 0xc0 ) == 0xc0 ) || ( c < 0x80 ) ) // soCg
        {
          if ( wc != 0 )
          {
            *wcs++ = wc;
            wc = 0;
          }
          if ( ( c & 0x80 ) == 0 )
          {
            wc = static_cast< wchar_t >( c );
          }
          else if ( ( c & 0xe0 ) == 0xc0 )
          {
            wc = static_cast< wchar_t >( c & 0x1f );
          }
          else if ( ( c & 0xf0 ) == 0xe0 )
          {
            wc = static_cast< wchar_t >( c & 0xf );
          }
          else
          {
            // TQ[g͖ΉiőΉƂĂAR[hϊɂ\j
          }
        }
        else    // 㑱oCg
        {
          wc = static_cast< wchar_t >( ( wc << 6 ) | ( c & 0x3f ) );
        }
      }
      if ( wc != 0 )
      {
        *wcs++ = wc;
      }
      *wcs = L'\0';

      //  ̊Ԃ͌ėOȂ
      char const* locale = std::setlocale( LC_CTYPE, "" );
      /* std:: */wcstombs( buf.get(), wbuf.get(), size + 1 );     // Unicode ˑ̕R[h֕ϊ
      std::setlocale( LC_CTYPE, locale );
      //  ̊Ԃ͌ėOȂ

      msgcat[ msgid ] = std::string( buf.get() );
    }

    bool msgcat_loaded = false;

  }

  /*!
   *  \brief      bZ[WJ^Õ[h
   *  \param[in]  dir     *.po t@C݂fBNg
   *  \retval     true    
   *  \retval     false   s
   *
   *  ȕ։邽߁A.pot@C̋Lq@ɂ͈ȉ̐񂪂B
   *  - msgid, msgstr ͕Ks̐擪ɋLqB
   *  - msgid, msgstr ̒ɂ́AK󔒗ޕꕶƂA̒ɕLqB
   *  - ݂̂Lqs͕K " Ŏn߂B
   *  - .pot@C͂̕R[h͕K UTF-8N ƂB
   */
  bool load_msgcat( std::string const& dir )
  {
    namespace fs = boost::filesystem;
    char const* env = std::getenv( "TOPPERS_CFG_LANG" );
//      env = "ja";
    if ( env == 0 )
    {
      return false;
    }
    std::string lang( env );

    fs::path cfg_dir( dir, fs::native );
    fs::path po_file( cfg_dir/fs::path( lang + ".po", fs::native ) );
    std::ifstream ifs( po_file.native_file_string().c_str() );
    std::string msgid;
    std::string msgstr;

    while ( ifs )
    {
      std::string str;
      std::getline( ifs, str );

      // s̈Ⴂz
      std::string::size_type pos = str.find_last_not_of( " \t\r\n" ); // łɍs̋󔒗ނ
      if ( pos != std::string::npos && pos < str.size() - 1 )
      {
        char c = str[pos];
        str.erase( pos + 1, std::string::npos );
      }

      if ( str.empty() || str[ 0 ] == '#' || str == "" )
      {
        ;   // s܂̓Rgs
      }
      else
      {
        try
        {
          if ( std::strncmp( str.c_str(), "msgid", sizeof( "msgid" )-1 ) == 0 )
          {
            str.erase( 0, sizeof( "msgid" )-1+1 );
            msgid = expand_quote( str );           
          }
          else if ( std::strncmp( str.c_str(), "msgstr", sizeof( "msgstr" )-1 ) == 0 )
          {
            str.erase( 0, sizeof( "msgstr" )-1+1 );
            msgstr = expand_quote( str );
          }
          else
          {
            msgstr += expand_quote( str );
          }
          if ( !msgid.empty() && !msgstr.empty() )  // O msgid / msgstr o^
          {
            register_msgcat( msgid, msgstr );
            msgid.clear();
            msgstr.clear();
          }
        }
        catch ( std::invalid_argument& )
        {
          return false;
        }
      }
    }
    msgcat_loaded = true;
    return true;
  }

  /*!
   *  \brief      bZ[W̖|
   *  \param[in]  message   bZ[WID
   *  \return     |̃bZ[W
   */
  std::string const& gettext( std::string const& message )
  {
    static bool f = load_msgcat( get_global< std::string >( "cfg-directory" ) );
    if ( !msgcat_loaded )
    {
      return message;
    }

    std::map< std::string, std::string >::const_iterator iter( msgcat.find( message ) ), last( msgcat.end() );
    if ( iter != last )
    {
      std::string const& result( iter->second );
      return result;
    }
    return message;
  }

}
